searchData={"items":[{"type":"module","title":"Apple.WeatherKit","doc":"An client for Apple's WeatherKit REST API.","ref":"Apple.WeatherKit.html"},{"type":"module","title":"Quick Start - Apple.WeatherKit","doc":"Before using `Apple.WeatherKit`, you need a basic understanding of the\nWeatherKit REST API. Checkout [WeatherKit REST API](https://developer.apple.com/documentation/weatherkitrestapi).\n\nThen, you can start using this package:\n\n    # 1. build the config\n    config =\n      Apple.WeatherKit.Config.new!(\n        team_id: \"XXXXXXXXXX\",\n        service_id: \"com.example.weatherkit-client\",\n        key_id: \"YYYYYYYYYY\",\n        private_key: \"-----BEGIN PRIVATE KEY-----\\n...\\n-----END PRIVATE KEY-----\"\n      )\n\n    # 2. make the request\n    Apple.WeatherKit.current_weather(config, 27.637, 120.699)\n\n    # It returns:\n    #\n    # {:ok,\n    #  %{\n    #    \"currentWeather\" => %{\n    #      \"asOf\" => \"2024-02-25T09:24:38Z\",\n    #      \"cloudCover\" => 0.39,\n    #      \"cloudCoverHighAltPct\" => 0.0,\n    #      \"cloudCoverLowAltPct\" => 0.6,\n    #      # ...\n    #    }\n    #  }\n    # }\n\n> You may notice that `Apple.WeatherKit` won't process body further after\n> receiving the response.\n>\n> If you want to further process the body, for example, converting the map keys\n> from camel case to snake case (which is used in Elixir conventionally), you have\n> to do it by yourself.\n>\n> If you don't have any preference, you might consider using [`cozy_case`](https://hexdocs.pm/cozy_case/),\n> which supports this use case, and provides related [examples](https://hexdocs.pm/cozy_case/CozyCase.html#module-examples).","ref":"Apple.WeatherKit.html#module-quick-start"},{"type":"module","title":"All possible values of `conditionCode`? - Apple.WeatherKit","doc":"WeatherKit REST API doesn't provide a list of all possible `conditionCode`,\nbut WeatherKit Swift API does.\n\nPlease check out `Apple.WeatherKit.Condition` for more information.","ref":"Apple.WeatherKit.html#module-all-possible-values-of-conditioncode"},{"type":"module","title":"References - Apple.WeatherKit","doc":"* [WeatherKit REST API](https://developer.apple.com/documentation/weatherkitrestapi)\n  * [WeatherKit](https://developer.apple.com/documentation/weatherkit)","ref":"Apple.WeatherKit.html#module-references"},{"type":"function","title":"Apple.WeatherKit.attribution/2","doc":"Obtains attribution information.","ref":"Apple.WeatherKit.html#attribution/2"},{"type":"function","title":"Apple.WeatherKit.available_data_sets/3","doc":"Obtains the list of data sets available for the requested location.\n\nWhen `country_code` argument is provided, the data sets of air quality\nand weather alerts will be taken into consideration, or they are will\nbe always ignored from the list.","ref":"Apple.WeatherKit.html#available_data_sets/3"},{"type":"function","title":"Apple.WeatherKit.available_data_sets/4","doc":"","ref":"Apple.WeatherKit.html#available_data_sets/4"},{"type":"function","title":"Apple.WeatherKit.current_weather/4","doc":"Obtains the current weather for the requested location.","ref":"Apple.WeatherKit.html#current_weather/4"},{"type":"function","title":"Options - Apple.WeatherKit.current_weather/4","doc":"* `language` - the name of language. Default to `\"en\"`.\n  * `currentAsOf` - the UTC datetime string to obtain current conditions. Default to UTC datatime string of now, like `\"2024-02-15T19:23:45Z\"`.","ref":"Apple.WeatherKit.html#current_weather/4-options"},{"type":"function","title":"Apple.WeatherKit.forecast_daily/4","doc":"Obtains the daily forecast for the requested location.","ref":"Apple.WeatherKit.html#forecast_daily/4"},{"type":"function","title":"Options - Apple.WeatherKit.forecast_daily/4","doc":"* `language` - the name of language. Default to `\"en\"`.\n  * `timezone` - the name of timezone which is use for rolling up weather forecasts into daily forecasts.Default to `\"GMT/UTC\"`.\n  * `dailyStart` - The UTC datetime string whose day will be used to start the daily forecast. Default to UTC datetime string of now, like `\"2024-02-15T19:23:45Z\"`.\n  * `dailyEnd` - The UTC datetime string whose day will be used to end the daily forecast. Default to UTC datetime string of now plus 10 days, like `\"2024-02-25T19:23:45Z\"`.","ref":"Apple.WeatherKit.html#forecast_daily/4-options"},{"type":"function","title":"Apple.WeatherKit.forecast_hourly/4","doc":"Obtains the hourly forecast for the requested location.","ref":"Apple.WeatherKit.html#forecast_hourly/4"},{"type":"function","title":"Options - Apple.WeatherKit.forecast_hourly/4","doc":"* `language` - the name of language. Default to `\"en\"`.\n  * `hourlyStart` - The UTC datetime string whose hour will be used to start the hourly forcast.Default to UTC datetime string of now, like `\"2024-02-15T19:23:45Z\"`.\n  * `hourlyEnd` - The UTC datetime string whose hour will be used to end the hourly forcast.Default to UTC datetime string of 24 hours or the length of the daily forecast, whichever is longer, like `\"2024-02-16T19:23:45Z\"`.","ref":"Apple.WeatherKit.html#forecast_hourly/4-options"},{"type":"function","title":"Apple.WeatherKit.forecast_next_hour/4","doc":"Obtains the next hour forecast for the requested location.","ref":"Apple.WeatherKit.html#forecast_next_hour/4"},{"type":"function","title":"Options - Apple.WeatherKit.forecast_next_hour/4","doc":"* `language` - the name of language. Default to `\"en\"`.\n  * `currentAsOf` - the UTC datetime string to obtain current conditions. Default to UTC datatime string of now, like `\"2024-02-15T19:23:45Z\"`.","ref":"Apple.WeatherKit.html#forecast_next_hour/4-options"},{"type":"macro","title":"Apple.WeatherKit.is_latitude/1","doc":"","ref":"Apple.WeatherKit.html#is_latitude/1"},{"type":"macro","title":"Apple.WeatherKit.is_longitude/1","doc":"","ref":"Apple.WeatherKit.html#is_longitude/1"},{"type":"function","title":"Apple.WeatherKit.weather_alerts/5","doc":"Obtains weather alerts for the requested location.","ref":"Apple.WeatherKit.html#weather_alerts/5"},{"type":"function","title":"Options - Apple.WeatherKit.weather_alerts/5","doc":"* `language` - the name of language. Default to `\"en\"`.\n  * `timezone` - the name of timezone which is use for rolling up weather forecasts into daily forecasts.Default to `\"GMT/UTC\"`.","ref":"Apple.WeatherKit.html#weather_alerts/5-options"},{"type":"function","title":"Apple.WeatherKit.weather_batch/5","doc":"Obtains data sets for the requested location in batch.","ref":"Apple.WeatherKit.html#weather_batch/5"},{"type":"function","title":"Options - Apple.WeatherKit.weather_batch/5","doc":"* `language` - the name of language. Default to `\"en\"`.\n  * `timezone` - the name of timezone which is use for rolling up weather forecasts into daily forecasts.Default to `\"GMT/UTC\"`.\n  * `currentAsOf` - the UTC datetime string to obtain current conditions. Default to UTC datatime string of now, like `\"2024-02-15T19:23:45Z\"`.\n  * `dailyStart` - The UTC datetime string whose day will be used to start the daily forecast. Default to UTC datetime string of now, like `\"2024-02-15T19:23:45Z\"`.\n  * `dailyEnd` - The UTC datetime string whose day will be used to end the daily forecast. Default to UTC datetime string of now plus 10 days, like `\"2024-02-25T19:23:45Z\"`.\n  * `hourlyStart` - The UTC datetime string whose hour will be used to start the hourly forcast.Default to UTC datetime string of now, like `\"2024-02-15T19:23:45Z\"`.\n  * `hourlyEnd` - The UTC datetime string whose hour will be used to end the hourly forcast.Default to UTC datetime string of 24 hours or the length of the daily forecast, whichever is longer, like `\"2024-02-16T19:23:45Z\"`.\n  * `countryCode` - The ISO Alpha-2 country code for the requested location, like `\"US\"`.","ref":"Apple.WeatherKit.html#weather_batch/5-options"},{"type":"function","title":"Examples - Apple.WeatherKit.weather_batch/5","doc":"Apple.WeatherKit.weather_batch(config, 27.637, 120.699, [\"currentWeather\", \"forecastDaily\", \"forecastHourly\"])","ref":"Apple.WeatherKit.html#weather_batch/5-examples"},{"type":"type","title":"Apple.WeatherKit.country_code/0","doc":"The ISO Alpha-2 country code for the requested location, like `\"US\"`.","ref":"Apple.WeatherKit.html#t:country_code/0"},{"type":"type","title":"Apple.WeatherKit.data_set/0","doc":"Available data sets.\n\nIt can be:\n\n  * `\"currentWeather\"`\n  * `\"forecastDaily\"`\n  * `\"forecastHourly\"`\n  * `\"forecastNextHour\"`\n  * `\"weatherAlerts\"`","ref":"Apple.WeatherKit.html#t:data_set/0"},{"type":"type","title":"Apple.WeatherKit.data_sets/0","doc":"The data sets to include in the response for batch request.","ref":"Apple.WeatherKit.html#t:data_sets/0"},{"type":"type","title":"Apple.WeatherKit.language/0","doc":"The name of language, like `\"en\"`, `\"zh-CN\"`, `\"zh-HK\"`.","ref":"Apple.WeatherKit.html#t:language/0"},{"type":"type","title":"Apple.WeatherKit.latitude/0","doc":"The latitude of the requested location.\n\nThe value should be between `-90` and `90`.","ref":"Apple.WeatherKit.html#t:latitude/0"},{"type":"type","title":"Apple.WeatherKit.longitude/0","doc":"The longitude of the requested location.\n\nThe value should be between `-180` and `180`.","ref":"Apple.WeatherKit.html#t:longitude/0"},{"type":"type","title":"Apple.WeatherKit.result/0","doc":"","ref":"Apple.WeatherKit.html#t:result/0"},{"type":"module","title":"Apple.WeatherKit.Condition","doc":"Provides static data about conditions.","ref":"Apple.WeatherKit.Condition.html"},{"type":"function","title":"Apple.WeatherKit.Condition.list_conditions/0","doc":"Lists all possible conditions.\n\nEvery condition contains three attributes:\n\n  * `code` (string)\n  * `type` (string), possible values are:\n    * `\"visibility\"`\n    * `\"wind\"`\n    * `\"precipitation\"`\n    * `\"hazardous\"`\n    * `\"winter-precipitation\"`\n    * `\"hazardous-winter\"`\n    * `\"tropical-hazard\"`\n  * `description` (string)\n\n> All the possible conditions are extracted from\n[WeatherKit / WeatherCondition](https://developer.apple.com/documentation/weatherkit/weathercondition).","ref":"Apple.WeatherKit.Condition.html#list_conditions/0"},{"type":"module","title":"Apple.WeatherKit.Config","doc":"Builds `%Config{}` struct with required options.\n\n## `team_id`\n\nThe 10-character Team ID from your developer account.\n\n## `service_id`\n\nThe registered Service ID, like `\"com.example.weatherkit-client\"`.\n\n## `key_id`\n\nA 10-character private key identifier you obtain from your developer account.\n\n## `private_key`\n\nThe content of private key which is downloaded from your developer account,\nlike:\n\n```\n-----BEGIN PRIVATE KEY-----\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\nxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx\nxxxxxxxxx\n-----END PRIVATE KEY-----\n```","ref":"Apple.WeatherKit.Config.html"},{"type":"module","title":"But, how to get these values? - Apple.WeatherKit.Config","doc":"Read [\"Create a private key and Service ID\" section of Request authentication for WeatherKit REST API](https://developer.apple.com/documentation/weatherkitrestapi/request_authentication_for_weatherkit_rest_api#4042234)\nfor more details.","ref":"Apple.WeatherKit.Config.html#module-but-how-to-get-these-values"},{"type":"function","title":"Apple.WeatherKit.Config.new/1","doc":"","ref":"Apple.WeatherKit.Config.html#new/1"},{"type":"function","title":"Apple.WeatherKit.Config.new!/1","doc":"","ref":"Apple.WeatherKit.Config.html#new!/1"},{"type":"type","title":"Apple.WeatherKit.Config.t/0","doc":"","ref":"Apple.WeatherKit.Config.html#t:t/0"},{"type":"module","title":"Apple.WeatherKit.I18n","doc":"Provides utilities for i18n.","ref":"Apple.WeatherKit.I18n.html"},{"type":"function","title":"Apple.WeatherKit.I18n.condition_name/2","doc":"Gets the localized name of an condition code.\n\n> Currently, only limited locales (`\"en\"`, `\"zh-Hans\"`, `\"zh-Hant\"`) are\n> supported, If you want to get support for more locales, or improve the\n> existing locales, consider to contribute.","ref":"Apple.WeatherKit.I18n.html#condition_name/2"},{"type":"function","title":"Examples - Apple.WeatherKit.I18n.condition_name/2","doc":"iex> Apple.WeatherKit.I18n.condition_name(\"MostlyCloudy\", \"en\")\n    {:ok, \"Mostly Cloudy\"}\n\n    iex> Apple.WeatherKit.I18n.condition_name(\"MostlyCloudy\", \"zh-Hans\")\n    {:ok, \"大部多云\"}\n\n    iex> Apple.WeatherKit.I18n.condition_name(\"unknown condition code\", \"en\")\n    :error\n\n    iex> Apple.WeatherKit.I18n.condition_name(\"MostlyCloudy\", \"unknown locale\")\n    :error","ref":"Apple.WeatherKit.I18n.html#condition_name/2-examples"},{"type":"type","title":"Apple.WeatherKit.I18n.condition_code/0","doc":"","ref":"Apple.WeatherKit.I18n.html#t:condition_code/0"},{"type":"type","title":"Apple.WeatherKit.I18n.locale/0","doc":"","ref":"Apple.WeatherKit.I18n.html#t:locale/0"},{"type":"module","title":"Apple.WeatherKit.Request","doc":"Provides basic HTTP request utilities.\n\nReferences:\n\n  * [Request authentication for WeatherKit REST API](https://developer.apple.com/documentation/weatherkitrestapi/request_authentication_for_weatherkit_rest_api)","ref":"Apple.WeatherKit.Request.html"},{"type":"function","title":"Apple.WeatherKit.Request.get/3","doc":"","ref":"Apple.WeatherKit.Request.html#get/3"},{"type":"exception","title":"Apple.WeatherKit.ConfigError","doc":"","ref":"Apple.WeatherKit.ConfigError.html"},{"type":"exception","title":"Apple.WeatherKit.RequestError","doc":"","ref":"Apple.WeatherKit.RequestError.html"},{"type":"extras","title":"Apple.WeatherKit","doc":"# Apple.WeatherKit\n\n[![CI](https://github.com/elixir-apple/apple_weather_kit/actions/workflows/ci.yml/badge.svg)](https://github.com/elixir-apple/apple_weather_kit/actions/workflows/ci.yml)\n[![Hex.pm](https://img.shields.io/hexpm/v/apple_weather_kit.svg)](https://hex.pm/packages/apple_weather_kit)\n[![built with Nix](https://img.shields.io/badge/built%20with%20Nix-5277C3?logo=nixos&logoColor=white)](https://builtwithnix.org)\n\nAn client for Apple's WeatherKit REST API.","ref":"readme.html"},{"type":"extras","title":"Notes - Apple.WeatherKit","doc":"This package is still in its early stages, so it may still undergo significant changes, potentially leading to breaking changes.","ref":"readme.html#notes"},{"type":"extras","title":"Installation - Apple.WeatherKit","doc":"Add `:apple_weather_kit` to the list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:apple_weather_kit,  }\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - Apple.WeatherKit","doc":"For more information, see the [documentation](https://hexdocs.pm/apple_weather_kit/Apple.WeatherKit.html).","ref":"readme.html#usage"},{"type":"extras","title":"License - Apple.WeatherKit","doc":"Apache License 2.0","ref":"readme.html#license"}],"content_type":"text/markdown"}